#!/bin/sh
###
# Copyright (C) 2016 Serg A. Kotlyarov <shadowsbrother@gmail.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the
# Free Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
# MA 02110-1301, USA.
#
###
# h - domain name for the hcl service
# mas - max limit in bytes for sending data

h=hcl.arenet.ru
mas=1843200

cd=" compressed data"
ehn="echo -n"

em=(
''
'Некорректный запрос'
'Некорректный аргумент'
'Ошибка в работе скрипта. Операция не выполнена'
'Не был правильно введен пароль root'
'Указанный файл не является текстовым UTF-8/ASCII либо пустым файлом'
'Указанный файл не является xz/bz2/gz архивом'
'Указанный файл пробы не существует или имеет нулевой размер'
'Указанный файл не существует'
'Ошибка работы утилиты system-report'
'Ошибка определения частоты процессора утилитой dmidecode'
'Утилита dmidecode определила несоответствующую формату частоту процессора'
'Ошибка работы утилиты hwinfo'
'Неподдерживаемый тип архива, созданный утилитой system-report'
'Не определен файл архива, создаваемый утилитой system-report'
'Не удалось определить домашний каталог пользователя'
'Не удалось инициализировать рабочий каталог'
'Не удалось инициализировать домашний каталог hcl-get'
'Не удалось инициализировать каталог для записи логов hcl-get'
'Проба вашего оборудования уже имеется в хранилище под номером '
'Указанная проба на сервере не найдена'
'Проба загружена, но не обработана'
'По запросу ничего не найдено'
'Функционал не реализован'
'Отправленные данные некорректны, см.'
'Произошла ошибка, см.'
'Данные пробы '
'были удалены из хранилища'
'Подготовка и отправка данных на сервер...'
'Подготовка данных к отправке...'
'Архив '
'успешно создан'
'Шифрование перед отправкой...'
'Отправка зашифрованного архива...'
'Отправка данных выполнена'
'Список проб не определен'
'Получение списка сохраненных проб'
'Указанная проба имеет номер: '
'Обнаружен установленный редактор mcedit. Запустить редактирование в нём ?'
'Запуск редактора'
'Не удалось найти исполняемый файл для '
'Проверка архивного файла на наличие в хранилище проб...'
'Комментарий к указанной пробе не существует'
'Комментарий к пробе существует:'
'Хотите его изменить ?'
'Комментарий для пробы '
'обработан'
'имя которого совпадает с полученным от сервера номером пробы, существует'
'Он сохранен как '
'Архив с собранными данными успешно сохранен как '
'Всего загружено проб: '
'Всего добавлено комментариев: '
'Данные о вашем оборудовании, подготовленные к отправке, успешно сохранены как'
'Версия клиента: '
'Повторить выбор или завершить работу ?'
'Хотите создать ?'
'Указанный файл не является зашифрованным с помощью gpg'
)

clean_tmp () {
if [[ $wd ]]; then
local r=
[[ $1 ]] && r="f $wd/*" || r="rf $wd"
rm -$r
fi
}

error () {
[[ $2 ]] || echo
$ehn ${em[$1]}
[[ $2 ]] && $ehn ": $2"$'\n' || echo
clean_tmp
case $1 in
 1[0-5]) rm -f /tmp/$wb.$b;;
esac
exit $1
}

err_or () {
clean_tmp
[[ $1 == 0 ]] && exit 0 || exit 3
}

###
# hh - home! home! (...Home! Home! Sweet, sweet home!...) ;)

hh=`printenv HOME`"/.hcl-get"
[[ $hh ]] || error 15

check_home () {
[[ -d $hh ]] || mkdir $hh
[[ $hh ]] || error 17
}

##
# hl - directory for logs

check_logs () {
[[ -d $hh ]] || check_home
hl=$hh/logs
[[ -d $hl ]] || mkdir $hl
[[ -d $hl ]] || error 18
}

###
# wd - working directory (for preparing files)
# wb - working directory's basename

make_tmp () {
[[ -d $hh ]] || check_home
ht=$hh/tmp
[[ -d $ht ]] || mkdir $ht
[[ $wd ]] || wd=`mktemp -d --tmpdir=$ht`
[[ $wd ]] || error 16
wb=`basename $wd`
}

###
# tnf - type number or file (for probe)
# tst - type some text (for comment)
# ta - type anything
# pt - if variable is defined then we must exit

press_type () {
local kp="Пробел/Enter/Tab -"
local ak="любая другая клавиша -"
local p="$kp продолжить, $ak завершить работу hcl-get"
local p1="$kp набор комментария в терминале, $ak выход"
local p2="$kp продолжить, $ak набор текста в терминале"
local p3="$kp запуск редактора, $ak набор в терминале"
local tp="Введите номер строки c нужной пробой или имя файла пробы"
local tp1="Введите имя файла пробы"
local tc="Наберите текст комментария"
ta= pt= tnf= tst=
$ehn "$(eval echo \$$1): "
case $1 in
 p|p1|p2|p3)
  read -s -n1 ta; echo;
  [[ `echo "$ta"|tr -d '\040'` ]] && pt=1;;
 tp|tp1)
  read tnf; [[ `echo "$tnf"|tr -d '\012'` ]] || press_type $1;;
 tc) read tst;;
esac
}

check_ue () {
[[ $sia == 'unmet' || $sia == 'error' ]] && err_or $?
}

send_we () {
echo "$sia" > $hl/$1.log
exec 1>&7 7>&-
echo "${em[$2]} $hl/$1.log"
exec 7>&1 >$hl/send_data.log
sia=$1
}

send_curl () {
check_logs
local co="-sD $hl/header.log" e=
[[ $aco ]] && co="$co $aco"
sia=`curl $co http://$h/$1`
chl=`cat $hl/header.log`
srh=`echo "$chl"|grep HTTP|cut -f2 -d ' '|tr -d [:cntrl:]`
declare -i srhi; let srhi=$srh 2>/dev/null
case $srhi in
 100200)
  link=`echo "$chl"|grep "Link:"|cut -f2 -d ' '`
  title=`echo "$chl"|grep "Title:"|cut -f2 -d ' '`
  [[ $link && $title ]] || io=2
  [[ `echo $link|tr -d [:cntrl:][:digit:]` ]] && io=1
  case $io in
   1) send_we unmet 24;;
   2) send_we error 25;;
  esac
  link=`echo $link|tr -d [:cntrl:]`
  title=`echo $title|tr -d [:cntrl:]`
  if [[ $link == $title ]]; then
   sia=$link
   [[ $link > 0 ]] && new=0
   [[ $link == 0 ]] && new=1
  else
   if [[ $link == 0 && $title > 0 ]]; then
    sia=$title
    new=1
   fi
  fi
  [[ $new ]] || error 34;;
 202)
  [[ $3 == q || $3 == g ]] && echo ${em[21]}
  [[ $3 == gc ]] && echo ${em[42]}
  [[ $3 == c ]] && sia=;;
 200)
  [[ $3 == q || $3 == g ||\
     $3 == gc || $3 == c ]] && sia=`echo "$sia"|sed "s,</pre>$,,;s,^<pre>,,"`
  [[ $3 != c ]] && echo "$sia";;
 404)
  case $3 in
   c) sia=;;
   q) echo ${em[22]};;
   r|g|gc)
    [[ $sia ]] && e="${em[26]}`echo $1|tr -d '~'` ${em[27]}" || e=${em[20]}
    echo $e;;
  esac;;
 400) echo ${em[1]};;
 501) echo ${em[23]};;
 *) error 34;;
esac
aco=
[[ $2 = "1" ]] && err_or $?
}

###
# at - archive target (target archive - архив, отправляемый на сервер)

send_data () {
if [[ $1 != 'gpg' ]]; then
 make_tmp
 echo ${em[29]}
 local b= c= br=
 for b in $fpc $fpr
 do
  if [[ ! $b ]]; then
   [[ $b == $fpc ]] && continue || error 7
  fi
  if [[ $b == $fpc ]]; then
   [[ -f $wd/comment ]] && continue || c=$wd/comment
  fi
  local op=
  [[ `dirname $b` != $wd ]] && op=cp || op=mv
  if [[ $b == $fpr ]]; then
   br=`basename $fpr`; c=$wd/hcl-get.tar.${br##*.}
  fi
  [[ $b == $c ]] || $op $b $c
  op=
  c=
 done
 pat=$wd/$wb.tar
 case $1 in
  arc)
   for e in xz bzip2 gzip
   do
    type $e >/dev/null 2>&1
    [[ $? == 0 ]] || continue
    case $e in
     xz) e='.xz'; c='J';;
     bzip2) e='.bz2'; c='j';;
     gzip) e='.gz'; c='g';;
    esac
    break
   done
   at="$pat$e";;
  tar) at=$pat; tc='-c';;
 esac
 tar "-c$c" $wd/* > $at 2>$hl/tar.log
 as=`du -b $at|cut -f1`
 if [[ $as -gt $mas ]]; then
  exec 1>&7 7>&-
  echo "Файлы логов вашего компьютера занимают довольно много места на диске"\
  $'\n'"(итоговый архив с собранными данными получился объемом $as байт)."\
  $'\n'"На сервере для архивов-ключей места достаточно, но, согласитесь, что ключ"\
  $'\n'"доступа к серверу размером почти в два мегабайта для манипуляций с комментарием"\
  $'\n'"пробы это несколько многовато."\
  $'\n'"Рекомендуется проверить содержимое файлов в /var/log/kernel на предмет ошибок,"\
  $'\n'"сообщений-предупреждений и другой информации, которая может свидетельствовать о"\
  $'\n'"проблемах с вашей системой. Если ничего подозрительного найдено не было, то"\
  $'\n'"вполне можно обнулить все или некоторые особо увесистые файлы для уменьшения"\
  $'\n'"размера получаемого архива-ключа с пробой."\
  $'\n'"Максимально возможный размер архива: $mas байт."
  exit 3
 fi
 echo "${em[30]}$at ${em[31]}"
 echo "$at:"$'\n' > $hl/tar.list
 tar -tf $at >> $hl/tar.list
 echo ${em[32]}
 cp /usr/share/libhcl/gpg/* $wd
 gpg --home $wd -e -r hcl-data $at 2>$hl/gpg.log
 [[ $2 == 'prepare' ]] && return
fi
echo ${em[33]}
aco="-F probe=@$at.gpg"
send_curl "upload" 0
echo ${em[34]}
}

data_transfer () {
check_logs
exec 7>&1 >$hl/send_data.log
send_data $1
exec 1>&7 7>&-
}

###
# cpl - contains a list of all detected probes in $hh

get_probes_list () {
local dot="$ehn ."
local pl_null=$'\n'${em[35]}
$ehn ${em[36]}
if [[ $cpl ]]; then
 $dot
else
 check_logs
 local a1= b= c= d= e= e1 f1= f2= g= h= l1=stat l2=arch
 local lp1=$wd/lp lp2=$wd/lp1
 pl=$hl/probes.list
 ls -fd -1 $hh/* 2>/dev/null|grep -E '.tar.bz2$|.tar.gz$|.tar.xz$' > $lp1
 if [[ ! -s $lp1 ]]; then
  echo "$pl_null"
  rm -f $lp1
  return 1
 fi
 file -f $lp1|\
  grep -E "bzip2$cd|xz$cd|gzip$cd"|cut -f1 -d':' > $lp2
 b=`cat $lp2|sed "s,$hh/,,"`; c=`echo "$b"|wc -l`
 for ((a1=1;a1<=c;a1++))
 do
  d=`echo "$b"|sed "$a1!D"`
  j=`du -b $hh/$d|cut -f1`
  [[ $j -gt $mas ]] && continue
  e=`tar -tf $hh/$d|grep -E "/$l1$|/$l2$"`
  [[ `echo "$e"|wc -l` -ne 2 ]] && continue
  echo $e|\
   while read e1; do
    tar --xform='s/.*\///' -xf $hh/$d -C $wd $e1
   done
  f1=`cat $wd/$l1`; f2=`cat $wd/$l2`
  g=`basename $d`
  h="$h$g ---> $f2, $f1"$'\n'
  [[ $(($a1 % 2)) -ne 0 ]] && $dot
 done
 if [[ ! $h ]]; then
  echo "$pl_null"
  return 1
 fi
 cpl=`echo "$h"|nl -nrz -w1 -s". "`
 clean_tmp f
fi
echo
echo $'\n'"$cpl"
}

check_ni () {
declare -i ia=; let ia=$i 2>/dev/null
if [[ $ia == 0 ]]; then ca=$i
else
 if [[ $cpl ]]; then ca=$ia
 else
  for ext in xz bz2 gz
  do
   [[ -s $hh/$ia.tar.$ext ]] || continue
   ca=$ia.tar.$ext
   break
  done
 fi
fi
}

###
# fpc - a full path of a comment
# fpr - a full path of a report

check_file () {
local tf=('UTF-8 Unicode text' 'UTF-8 Unicode (with BOM) text' \
'ASCII text' 'empty' "bzip2$cd" "gzip$cd" "xz$cd" ': data')
local i=
for i in $@
do
 local ff=
 check_ni
 if [[ $tnf ]]; then
  [[ $tnf == 0 ]] && return 1
  if [[ $cpl ]]; then 
   local fn=
   fn=`echo "$cpl"|grep "^$ca. "|cut -f2 -d ' '`
   [[ $fn ]] || return 1
   ca=$fn
  fi
 fi
 [[ -f $ca ]] && ff=$ca
 [[ -f $hh/$ca ]] && ff=$hh/$ca
 [[ -f $hh/gpg/$ca ]] && ff=$hh/gpg/$ca
 if [[ $tnf ]]; then
  [[ $ff ]] || return 2
 else
  [[ $ff ]] || error 8 $ca
 fi 
 local fj=`file $ff` oifs="$IFS" IFS=$'\n' tk=1
 for j in ${tf[*]}
 do
  if [[ ! `echo $fj|grep "$j"` ]]; then
   tk=$[$tk+1]
   continue
  fi
  if [[ $tk < 4 ]]; then fpc=$ff
  else
   [[ $tk < 8 ]] && fpr=$ff
   [[ $tk > 7 ]] && fgf=$ff
  fi
  break
 done
 IFS="$oifs"
 if [[ $# == 1 && ! $fpr && ! $fpc && ! $fgf ]]; then
  echo ${em[7]}$'\n'${em[6]}$'\n'${em[56]}; err_or $?
 fi
done
if [[ $# == 2 ]]; then
 if [[ $fgf ]]; then echo ${em[5]}$'\n'${em[6]}; err_or $?; fi
 [[ $fpr && ! $fpc ]] && error 5
 [[ $fpc && ! $fpr ]] && error 6
fi
}

get_file_report () {
[[ $2 ]] || echo ${em[28]}
data_transfer tar
clean_tmp f
if [[ ! $2 ]]; then
 [[ $new == 1 ]] && echo ${em[20]} || echo ${em[37]}$sia
 err_or $?
fi
}

ext_editor () {
[[ $2 == 1 ]] && echo "$sia" > $gc
echo "--->"
$1 $gc
echo "<---"
}

get_comment_from_input () {
local wme=`whereis mcedit|grep -E 'bin|sbin'`
if [[ $wme ]]; then
 echo ${em[38]}
 press_type p3
 if [[ $pt ]]; then
  press_type tc
  echo "$tst" > $gc
 else
  echo "${em[39]} mcedit"
  ext_editor mcedit $1
 fi
else
 press_type tc
 echo "$tst" > $gc
fi
[[ `file $gc|grep ': very short file (no magic)$'` ]] && cp -f /dev/null $gc
}

get_comment () {
make_tmp
local gc=$wd/$wb.txt es=`printenv EDITOR`
local gcfi=get_comment_from_input ee=ext_editor
case $1 in
 0) gcfi="$gcfi 0";;
 1) gcfi="$gcfi 1";;
esac
if [[ ! $es ]]; then $gcfi
else
 wes=`whereis $es|grep -E 'bin|sbin'`
 if [[ $wes ]]; then
  wes=`echo $wes|sed "s,^$es:,,"|cut -f2 -d' '`
  case $1 in
   0) ee="$ee $wes 0";;
   1) ee="$ee $wes 1";;
  esac
  echo "${em[39]} $es"
  press_type p2
  [[ $pt ]] && $gcfi || $ee
 else
  echo "${em[40]}$es"
  press_type p1
  [[ $pt ]] && err_or $?
  $gcfi
  return
 fi
fi
if [[ ! -f $gc ]]; then cp -f /dev/null $gc
else
 [[ `file $gc|grep ': very short file (no magic)$'`\
    || ! `cat $gc|sed "s,\x0A,,"` ]] && cp -f /dev/null $gc
fi
fpc=$gc
}

get_probe () {
local rc=
press_type $1
check_file $tnf
rc=$?
case $rc in
 1) get_probe $1;;
 2) echo ${em[8]}". ${em[54]}"; press_type p
    [[ $pt ]] && err_or $? || get_probe $1;;
esac
}

make_check_choice () {
if [[ ! $1 ]]; then
 get_probes_list
 [[ $? == 1 ]] && mcc=tp1 || mcc=tp
 get_probe $mcc
fi
echo ${em[41]}
get_file_report $fpr 1
if [[ $new == 1 || $sia == 'unmet' || $sia == 'error' ]]; then
 echo "${em[20]}. ${em[54]}"
 press_type p
 [[ $pt ]] && err_or $?
 clean_tmp f
 [[ $1 ]] && make_check_choice $1 || make_check_choice
fi
[[ $sia > 0 ]] && return
}

comment_choice () {
if [[ $sia ]]; then
 echo ${em[43]}$'\n'"--->"$'\n'"$sia"$'\n'"<---"
 echo ${em[44]}; 
 cg=1
else
 echo "${em[42]}. ${em[55]}";
 cg=0
fi
press_type p
[[ $pt ]] && err_or $? || get_comment $cg
}

check_comment () {
send_curl "~$1" 0 c
comment_choice
}

check_probe () {
make_check_choice $1
data_transfer tar
clean_tmp f
}

put_comment_report () {
make_tmp
case $1 in
# без параметров
 0)
  check_probe
  check_comment $sia;;
# номер_пробы
 1)
  check_file $2
  make_check_choice $fpr
  check_comment $2;;
# файл_комментария, файл_пробы
 2)
  check_file $2
  if [[ $fpc && ! $fpr ]]; then
   tfpc=$fpc; fpc=
   make_check_choice
   fpc=$tfpc; tfpc=
  fi
  if [[ $fpr && ! $fpc ]]; then
   check_probe $fpr
   comment_choice
  fi;;
# файл_комментария файл_пробы, файл_комментария файл_пробы 3)
# номер_пробы "комментарий", файл_пробы "комментарий" 4)
esac
[[ $1 == 2 || $1 == 4 ]] || echo ${em[28]}
data_transfer tar
check_ue
[[ $new == 1 ]] && echo ${em[26]}${em[27]}
[[ $sia > 0 ]] && echo "${em[45]}$sia ${em[46]}"
err_or $?
}

###
# b - just a seamark for the hcl-root script
# au - archive file that has been uploaded

put_file_report () {
if [[ $1 != 'gpg' ]]; then
 local a='hcl-get.tar' b='tmp.hcl-get' ld1= d2= ext=
 make_tmp
 if [[ `whoami` != "root" ]]; then
  $ehn "Для операций сбора информации о системе требуются права root."\
  $'\n'"Введите пароль root и нажмите Enter (пароль при наборе отображаться не будет): "
 else
  echo "Внимание. Вы запустили hcl-get с правами root, чего делать не рекомендуется."\
  $'\n'"Это будет означать, что создаваемый архив с пробой (он же ключ доступа к серверу"\
  $'\n'"для работы с комментарием пробы или для любых других возможных задач) будет"\
  $'\n'"сохранен по пути /root/.hcl-get и для того, чтобы иметь возможность выполнять"\
  $'\n'"подобные задачи, hcl-get должен иметь доступ к этому файлу архива также с"\
  $'\n'"правами root. Другими словами, для выполнения подобных задач запускать hcl-get в"\
  $'\n'"дальнейшем вам придется только с правами root. Например, создавать комментарий"\
  $'\n'"для пробы по пути /root/.hcl-get в этом случае придется с правами root. Можно,"\
  $'\n'"конечно, создать файл комментария и по другому пути, но в этом случае вам"\
  $'\n'"придется указывать полный путь к этому файлу. Также, если у вас есть архивный"\
  $'\n'"файл с пробой и вы хотите проверить, добавлен ли он в базу, но при этом файл"\
  $'\n'"располагается где-либо в /root, то вы должны будете запустить hcl-get с правами"\
  $'\n'"root."\
  $'\n'$'\n'"Вы уверены, что хотите продолжить?"
  press_type p
  [[ $pt ]] && err_or $?
 fi
 lf=`ls -fd -1 /tmp/* 2>/dev/null|grep '^/tmp.*.tmp.hcl-get$'`
 if [[ $lf ]]; then
  echo "$lf"|while read f1; do rm -f $f1; done
 fi
 echo $hh > /tmp/$wb.$b
 check_logs
 su - -c 'hcl-get-root' root 2>/dev/null
 [[ $? == 0 ]] || error 4
 [[ -s $wd/system-report.err ]] && error 9
 [[ -s $wd/frequency.err ]] && error 10
 [[ -s $wd/hwinfo.err ]] && error 12
 d1=`ls -fd -1 $wd/* 2>/dev/null|grep "/$a"`
 [[ ! $d1 || `echo "$d1"|wc -l` != 1 ]] && error 14
 if [[ ! `cat /proc/cpuinfo|grep '^model name.*[0-9][.0-9]*[GM]Hz$'` ]]; then
  cf=`cat $wd/frequency|uniq`
  echo "$cf"|\
  while read lcf
  do
   [[ `echo "$lcf"|sed 's, MHz$,,'` =~ ^[1-9][0-9]*$ ]] || error 11
  done
 fi
 ext=${d1##*.}
 f=$wd/$a.$ext
 [[ -s $f ]] || error 13 $f
 arch > $wd/arch
 stat --format=%y $f > $wd/stat
 lsb_release -a > $wd/lsb_release
 [[ $1 == 'prepare' ]] && return
 echo ${em[28]}
 data_transfer arc
fi
check_ue
if [[ $new == 1 ]]; then
 echo "Спасибо за ваш интерес к сервису HCL!"\
      $'\n'"Ваша проба принята и ей присвоен номер $sia"\
      $'\n'"После обработки доступ к данным вашей пробы можно получить:"\
      $'\n'"1) через браузер по ссылке http://$h/$sia"\
      $'\n'"2) через консоль командой hcl-get -gr $sia"
 if [[ `dirname $at` == $hh/gpg ]]; then
  aut=`basename $at`
  ext=${aut##*.}
  at=$hh/$aut
 else
  ext=${at##*.}
 fi
 au=$hh/$sia.tar.$ext
 if [[ -f $au ]]; then
  echo "${em[30]}$au,"$'\n'${em[47]}
  [[ $aut ]] && make_tmp
  auwb=$hh/$sia.$wb.tar.$ext
  mv $au $auwb
  echo "${em[48]}$auwb"
 fi
 cp $at $au
 echo "${em[49]}$au"
else
 echo "${em[19]}$sia"
fi
err_or $?
}

test_probes () {
make_tmp
check_probe
check_ue
[[ $new == 1 ]] && echo ${em[20]} || echo "${em[19]}$sia"
echo ${em[54]}
press_type p
[[ $pt ]] && err_or $? || test_probes
}

help () {
cat /usr/share/libhcl/hcl-help.txt
err_or $?
}

args () {
if [[ ! $2 ]]; then
 case $1 in
  -a|--all)
    a=`send_curl 0~ 0 a`
    echo ${em[50]}${a%%~*}; echo ${em[51]}${a##*~}; err_or $?;;
  -ac|--all-comments|-ar|--all-reports)
    case $1 in
     -ac|--all-comments) e="${em[51]}"`send_curl "~0" 0 a`;;
     -ar|--all-reports) e="${em[50]}"`send_curl 0 0 a`;;
    esac
    echo $e
    err_or $?;;
  -c|--comment) put_comment_report 0;;
  -h|--help) help;;
  -p|--prepare)
    make_tmp
    put_file_report prepare
    fpr=$f
    check_logs
    exec 7>&1 >$hl/prepare_data.log
    send_data arc prepare
    exec 1>&7 7>&-
    hg=$hh/gpg
    [[ -d $hg ]] || mkdir $hg
    bt=`basename $at`
    oa="$hh/$bt"; od="$hg/$bt.gpg"
    cp $at $oa; cp $at.gpg $od
    echo ${em[49]}$'\n'" $oa"
    echo ${em[52]}$'\n'" $od"
    err_or $?;;
  -r|--report) put_file_report;;
  -t|--test) test_probes;;
  -v|--version)
    echo ${em[53]}`rpm -q --queryformat=%{VERSION} hcl-get`
    err_or $?;;
 esac
fi
if [[ ! $3 ]]; then
 local -i ci
 let ci=$2 2>/dev/null
 case $1 in
  -c|--comment)
    [[ $ci -ne 0 ]] && put_comment_report 1 $ci || put_comment_report 2 $2;;
  -g|-gc|-gr|--get|--get-comment|--get-report)
    if [[ ! `echo $2|tr -d [:digit:]` && $ci > 0 ]]; then
     case $1 in
      -g|--get) e="$ci~"; g=g;;
      -gc|--get-comment) e="~$ci"; g=gc;;
      -gr|--get-report) e=$ci; g=g;;
     esac
     send_curl $e 1 $g
    fi;;
  -gq|--get-query)
    if [[ `echo "$2"|grep '~'` ]]; then
     a=`echo "$2"|cut -f1 -d'~'|tr -d ' '`
     b=`echo "$2"|cut -f2 -d'~'|tr -d ' '`
    fi
    [[ $b && ! $a ]] && gq=gc || gq=g
    send_curl "$2" 1 $gq;;
  -q|-qr|-qc|--query|--query-reports|--query-comment)
    if [[ $2 ]]; then
     aco="-d what=$2&where=${1##*-}"
     send_curl search 1 q
    fi;;
  -r|--report)
    if [[ $ci -eq 0 ]]; then
     check_file $2
     if [[ ${2##*.} != 'gpg' ]]; then
      get_file_report $fpr
     else
      at=${fgf%.*}; echo ${em[33]}; data_transfer gpg; put_file_report gpg
     fi
    fi;;
 esac
fi
if [[ $# -ge 3 ]] && [[ $1 == "-c" || $1 == "--comment" ]]; then
 if [[ $# == 3 ]]; then
  check_file $2 $3
  [[ $fpr && $fpc ]] && put_comment_report 3
 else
  check_file $2
  make_check_choice $fpr
  ic=`echo "$@"|sed "s,$1 $2 ,,"`
  make_tmp
  echo "$ic" > $wd/comment
  fpc=$wd/comment
  put_comment_report 4
 fi
fi
error 2 $1
}

[[ $1 ]] || help
args $1 $2 $3
